"use strict";

Object.defineProperty(exports, "t", {
    value: true
});

exports.default = void 0;

var _ContainerBase = require("../../ContainerBase");

class TreeIterator extends _ContainerBase.ContainerIterator {
    constructor(t, e, r) {
        super(r);
        this.I = t;
        this.L = e;
        if (this.iteratorType === 0) {
            this.pre = function() {
                if (this.I === this.L.left) {
                    throw new RangeError("Tree iterator access denied!");
                }
                this.I = this.I.pre();
                return this;
            };
            this.next = function() {
                if (this.I === this.L) {
                    throw new RangeError("Tree iterator access denied!");
                }
                this.I = this.I.next();
                return this;
            };
        } else {
            this.pre = function() {
                if (this.I === this.L.right) {
                    throw new RangeError("Tree iterator access denied!");
                }
                this.I = this.I.next();
                return this;
            };
            this.next = function() {
                if (this.I === this.L) {
                    throw new RangeError("Tree iterator access denied!");
                }
                this.I = this.I.pre();
                return this;
            };
        }
    }
    get index() {
        let t = this.I;
        const e = this.L.parent;
        if (t === this.L) {
            if (e) {
                return e.subTreeSize - 1;
            }
            return 0;
        }
        let r = 0;
        if (t.left) {
            r += t.left.subTreeSize;
        }
        while (t !== e) {
            const e = t.parent;
            if (t === e.right) {
                r += 1;
                if (e.left) {
                    r += e.left.subTreeSize;
                }
            }
            t = e;
        }
        return r;
    }
    equals(t) {
        return this.I === t.I;
    }
}

var _default = TreeIterator;

exports.default = _default;